# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class ServerConfigTranscoding(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'hls': 'ServerConfigEmail',
        'webtorrent': 'ServerConfigEmail',
        'enabled_resolutions': 'list[int]'
    }

    attribute_map = {
        'hls': 'hls',
        'webtorrent': 'webtorrent',
        'enabled_resolutions': 'enabledResolutions'
    }

    def __init__(self, hls=None, webtorrent=None, enabled_resolutions=None, local_vars_configuration=None):  # noqa: E501
        """ServerConfigTranscoding - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._hls = None
        self._webtorrent = None
        self._enabled_resolutions = None
        self.discriminator = None

        if hls is not None:
            self.hls = hls
        if webtorrent is not None:
            self.webtorrent = webtorrent
        if enabled_resolutions is not None:
            self.enabled_resolutions = enabled_resolutions

    @property
    def hls(self):
        """Gets the hls of this ServerConfigTranscoding.  # noqa: E501


        :return: The hls of this ServerConfigTranscoding.  # noqa: E501
        :rtype: ServerConfigEmail
        """
        return self._hls

    @hls.setter
    def hls(self, hls):
        """Sets the hls of this ServerConfigTranscoding.


        :param hls: The hls of this ServerConfigTranscoding.  # noqa: E501
        :type hls: ServerConfigEmail
        """

        self._hls = hls

    @property
    def webtorrent(self):
        """Gets the webtorrent of this ServerConfigTranscoding.  # noqa: E501


        :return: The webtorrent of this ServerConfigTranscoding.  # noqa: E501
        :rtype: ServerConfigEmail
        """
        return self._webtorrent

    @webtorrent.setter
    def webtorrent(self, webtorrent):
        """Sets the webtorrent of this ServerConfigTranscoding.


        :param webtorrent: The webtorrent of this ServerConfigTranscoding.  # noqa: E501
        :type webtorrent: ServerConfigEmail
        """

        self._webtorrent = webtorrent

    @property
    def enabled_resolutions(self):
        """Gets the enabled_resolutions of this ServerConfigTranscoding.  # noqa: E501


        :return: The enabled_resolutions of this ServerConfigTranscoding.  # noqa: E501
        :rtype: list[int]
        """
        return self._enabled_resolutions

    @enabled_resolutions.setter
    def enabled_resolutions(self, enabled_resolutions):
        """Sets the enabled_resolutions of this ServerConfigTranscoding.


        :param enabled_resolutions: The enabled_resolutions of this ServerConfigTranscoding.  # noqa: E501
        :type enabled_resolutions: list[int]
        """

        self._enabled_resolutions = enabled_resolutions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServerConfigTranscoding):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ServerConfigTranscoding):
            return True

        return self.to_dict() != other.to_dict()
